From 8b6b04c1459ce7c797a6ca90b4e9ed8bded87b1b Mon Sep 17 00:00:00 2001
From: Andrew Esh <andrew.esh@qterics.com>
Date: Wed, 17 May 2017 13:44:05 -0500
Subject: [PATCH 11/25] _common_ Add Android soname support for nettle

---
 ...-build-using-.word-for-assembly-constants.patch |  6 ++--
 ...002-Add-Android-soname-support-for-nettle.patch | 36 ++++++++++++++++++++++
 recipes/nettle/nettle.recipe                       |  3 +-
 3 files changed, 41 insertions(+), 4 deletions(-)
 create mode 100644 recipes/nettle/0002-Add-Android-soname-support-for-nettle.patch

diff --git a/recipes/nettle/0001-ios-fix-build-using-.word-for-assembly-constants.patch b/recipes/nettle/0001-ios-fix-build-using-.word-for-assembly-constants.patch
index d58ce41..969eb15 100644
--- a/recipes/nettle/0001-ios-fix-build-using-.word-for-assembly-constants.patch
+++ b/recipes/nettle/0001-ios-fix-build-using-.word-for-assembly-constants.patch
@@ -1,7 +1,7 @@
-From 9c2bd4a5fd64aa63558ea54bcd13d52eb50a9de9 Mon Sep 17 00:00:00 2001
+From 54e8ec5ad31569f85c854f834f98b7ff350af157 Mon Sep 17 00:00:00 2001
 From: Andoni Morales Alastruey <ylatuya@gmail.com>
 Date: Tue, 29 Oct 2013 17:59:29 +0100
-Subject: [PATCH] ios: fix build using .word for assembly constants
+Subject: [PATCH 1/2] ios: fix build using .word for assembly constants
 
 ---
  arm/ecc-521-modp.asm | 4 ++++
@@ -24,5 +24,5 @@ index c311a89..8cb5264 100644
  	.align 2
  
 -- 
-2.6.1
+2.10.2
 
diff --git a/recipes/nettle/0002-Add-Android-soname-support-for-nettle.patch b/recipes/nettle/0002-Add-Android-soname-support-for-nettle.patch
new file mode 100644
index 0000000..56942cb
--- /dev/null
+++ b/recipes/nettle/0002-Add-Android-soname-support-for-nettle.patch
@@ -0,0 +1,36 @@
+From 6e5d9285e385827dfd5cc3e95ad9eb1a0bfb52f7 Mon Sep 17 00:00:00 2001
+From: Andrew Esh <andrew.esh@qterics.com>
+Date: Tue, 1 Nov 2016 15:46:32 -0500
+Subject: [PATCH 2/2] Add Android soname support for nettle
+
+---
+ configure | 13 +++++++++++++
+ 1 file changed, 13 insertions(+)
+
+diff --git a/configure b/configure
+index 4955f97..3611512 100755
+--- a/configure
++++ b/configure
+@@ -7195,6 +7195,19 @@ case "$host_os" in
+     LIBHOGWEED_LINK='$(CC) $(CFLAGS) $(LDFLAGS) -G -h $(LIBHOGWEED_SONAME)'
+     LIBHOGWEED_LIBS='libnettle.so $(LIBS)'
+     ;;
++  linux*android*)
++    LIBNETTLE_FORLINK=libnettle.so
++    LIBNETTLE_SONAME=''
++    LIBNETTLE_FILE='$(LIBNETTLE_FORLINK)'
++    LIBNETTLE_LINK='$(CC) $(CFLAGS) $(LDFLAGS) -shared -Wl,-soname=$(LIBNETTLE_FILE)'
++    LIBNETTLE_LIBS=''
++
++    LIBHOGWEED_FORLINK=libhogweed.so
++    LIBHOGWEED_SONAME=''
++    LIBHOGWEED_FILE='$(LIBHOGWEED_FORLINK)'
++    LIBHOGWEED_LINK='$(CC) $(CFLAGS) $(LDFLAGS) -shared -Wl,-soname=$(LIBHOGWEED_FILE)'
++    LIBHOGWEED_LIBS='libnettle.so $(LIBS)'
++    ;;
+   *)
+     LIBNETTLE_FORLINK=libnettle.so
+     LIBNETTLE_SONAME='$(LIBNETTLE_FORLINK).$(LIBNETTLE_MAJOR)'
+-- 
+2.10.2
+
diff --git a/recipes/nettle/nettle.recipe b/recipes/nettle/nettle.recipe
index e3d9700..76bbc64 100644
--- a/recipes/nettle/nettle.recipe
+++ b/recipes/nettle/nettle.recipe
@@ -17,7 +17,8 @@ class Recipe(recipe.Recipe):
     licenses = [License.LGPLv2_1Plus]
     configure_options = '--enable-shared --enable-public-key'
     deps = ['gmp']
-    patches = ['0001-ios-fix-build-using-.word-for-assembly-constants.patch']
+    patches = ['0001-ios-fix-build-using-.word-for-assembly-constants.patch',
+               '0002-Add-Android-soname-support-for-nettle.patch']
     allow_parallel_build = False
 
     files_bins = ['nettle-hash', 'nettle-lfib-stream', 'nettle-pbkdf2']
-- 
2.15.0

